program fixavi;
{ fixes MJPEG AVI files from Canon PowerShot 100SX by changing audio
  sampling rate from 11024 Hz -> 11025 Hz ; Windows has trouble with
  playing at 11024 Hz }
{ version history:
   3.03.2009 - initial version
  14.03.2009 - fixed a minor bug regarding number of bytes read }

uses support;

const bufsize=10239;   { expects to find audio header in first 10 KB of file }
type tx4=array[1..4] of char;
     txptr=record case integer of
             0: (tx:^tx4);
             1: (ch:^byte);
             2: (num:^word);
           end;

var f:file;
    buffer:array [0..bufsize] of byte;
    curptr:txptr;
    nbytes,nb:integer;
    i:integer; found,ok,stop:boolean;

begin
if paramcount<1 then abort('Usage: '+GetMyName+' filename.avi');
assign(f,paramstr(1));
{$I-}
reset(f,1);
if IOResult<>0 then abort('Can''t open file '+paramstr(1));
{$I+}
BlockRead(f,buffer,sizeof(buffer),nbytes);
if nbytes=0 then begin close(f); abort('Error reading file'); end;
i:=0; found:=false; ok:=false; stop:=false;
while not stop and (i<=nbytes-4) do
  begin
  curptr.ch:=@buffer[i];
  if (i=0) and (curptr.tx^<>'RIFF') then
    begin
    close(f); abort('Improper file format');
    end;
  if curptr.tx^='auds' then found:=true;
  if found and (curptr.num^=11024) then
    begin
    ok:=true;
    curptr.num^:=11025;
    end;
  if found and (curptr.tx^='LIST') then stop:=true;
  i:=i+4;
  end;
if ok then
  begin
  {$I-}
  seek(f,0);
  if IOresult<>0 then
    begin
    close(f); abort('Error writing file');
    end;
  {$I+}
  BlockWrite(f,buffer,nbytes,nb);
  if nb<>nbytes then
    begin
    close(f); abort('Error writing file');
    end;
  writeln('File fixed OK');
  end
else
  if found then
    writeln('Nothing found to fix (file already OK?)')
  else
    writeln('Can''t find audio track - improper file format');
close(f);
end.
